#ifndef CLOCK
#define CLOCK

#include <stdlib.h>
#include <time.h>
#include <stdint.h>

struct timespec* currtime;
unsigned long thistime, lasttime;
unsigned long* currclock, * pausedclock;
unsigned int high, low;

//Initializes the timer
//int start_clocks();
#define start_clocks()

//Clocks record time in cycles
#define CLOCK_UNITS 'c'

//Begins adding time to specified long*
#define select_clock(timer) do \
{\
  __asm__ __volatile__ ("rdtsc" : "=a" (low), "=d" (high));\
  thistime = ((long) high << 32) | low;\
  if (currclock != NULL)\
    *currclock += thistime - lasttime;\
  currclock = timer;\
  lasttime = thistime;\
} while (0)

//Pauses and saves the current clock
#define pause_clock()  do\
{\
  pausedclock = currclock;\
  select_clock(NULL);\
} while (0)

//Restores and resumes the last paused clock
#define resume_clock() select_clock(pausedclock)

//Cleans up
#define stop_clocks()  do \
{\
  select_clock(NULL);\
} while(0)

#endif
