#ifndef __GRAPH_H
#define __GRAPH_H

#include <stdio.h>
#include <stdlib.h>

/** Data structure **/

typedef struct edge_t 
{
    unsigned int _vertex;
    struct edge_t *_next;
} Edge;

typedef struct vertex_t
{
    unsigned int _degree;
    unsigned char _active;
    Edge  *_edge_list;
    Edge *_tail;
} Vertex;

/* data structure of a graph */
typedef struct graph_t {
    unsigned int _num_vertices;  /* total number of vertices in graph */
    unsigned int _num_active_vertices; /* number of activer vertices */
    unsigned int _num_edges;     /* number of active edges */
    Vertex** _vertex;
} Graph;

Graph *make_graph(unsigned int num_vertices);
void delete_lower_degree_vertices(Graph *G, unsigned int k);
void free_graph(Graph *G);
void free_vertex(Vertex *V);
void add_edge(Graph *G, unsigned int u, unsigned int v);
Graph * read_graph(FILE *fp);
Graph * read_addition_graph(FILE *fp);

void print_graph(Graph *G);

#endif  /* __GRAPH_H */

